;; Copyright 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------
;; ispell

(progn
  (find-file "~/.mailcap")
  (goto-char (point-max))
  (forward-line -2)
  (ispell-region (point-min) (point-max)))

(string-match "/\\.?mailcap\\'" "~/.mailcap")

(progn
  (setq ispell-buffer-session-localwords '("x11-bitmap"))
  ;; x11-bitmap
  (ispell-kill-ispell))

;;-----------------
;; info

(progn
  (require 'info-look)
  (find-file "d-mailcap-mode.mailcap"))

;;-----------------------------------------------------------------------------
;; comment

(progn
  (find-file "/tmp/mailcap")
  (insert "   x\n    fd\n")
  (comment-region (point-min) (point-max)))


;;-----------------------------------------------------------------------------
;; auto-complete.el
;; /usr/share/doc/auto-complete-el/doc/manual.txt
;; /usr/share/emacs/site-lisp/auto-complete/auto-complete.el

(progn
  (add-to-list 'ac-dictionary-directories "~/.emacs.d/ac-dict")
  (find-file "/tmp/mailcap")
  )

(add-to-list 'mailcap-mode-hook 'auto-complete-mode)
auto-complete-mode

(add-to-list 'ac-user-dictionary '("xyzzy"))

(progn

  ;;   (add-hook 'mailcap-mode-hook
  ;;             (lambda ()
  ;;               ;; (add-to-list 'ac-sources 'ac-mailcap-mode-mime-types)
  ;;               ))

  (find-file "/tmp/mailcap")
  (auto-complete-mode 1)
  (set (make-local-variable 'ac-sources)
       '(mailcap-mode-ac-source-keywords))
  (set (make-local-variable 'ac-sources)
       '(mailcap-mode-ac-source-mime-types)))

(sort (mailcap-mime-types) 'string<)

(pp (mailcap-mode-mime-types) (current-buffer))


;;-----------------------------------------------------------------------------
;; mailcap-mode-syntax-table

(require 'mailcap-mode)
(with-temp-buffer
  (mailcap-mode)
  (insert "\\")
  (describe-char (point-min)))


;;-----------------------------------------------------------------------------
;; ispell

(defun skipper ()
  )

(defvar mailcap-mode-skip-keywords 
  "only-in-mailcap-mode\\`")

(eval-after-load "ispell"
  '(add-to-list 'ispell-skip-region-alist
                '(mailcap-mode-skip-keywords forward-word)))

   (set (make-local-variable 'mailcap-mode-skip-keywords)
        (eval-when-compile
          (concat "\\b"
                  (regexp-opt (append mailcap-mode-flag-keywords
                                      (mapcar (lambda (keyword)
                                                (concat keyword "="))
                                              mailcap-mode-namedflag-keywords))
                              t)))) ;; grouped by \( \)



;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------

;; (defun mailcap-mode-start-of-entry ()
;;   "Move point to the start of a mailcap entry."
;;   (while (progn
;;            (beginning-of-line)
;;            (equal (char-before) ?\\))))    
;; 
;; (defun mailcap-mode-start-of-fields ()
;;   (save-excursion
;;     (mailcap-mode-start-of-entry)
;;     (and (not (looking-at comment-start-skip))
;;          (progn
;;            (re-search-forward mailcap-mode-unescaped-semi-regexp
;;                               nil (line-end-position))
;;            (re-search-forward mailcap-mode-unescaped-semi-regexp
;;                               nil (line-end-position)))
;;          (point))))
;; 
;; ;; image/text; cat \; %s; \
;; ;;   description=Plain text
;; 
;; (defun mailcap-mode-font-lock-fields (limit)
;;   "Search for a mailcap field name up to LIMIT.
;; This function is designed for use as a `font-lock-keywords'
;; matcher.
;; 
;; Return nil if there's no field keywords.  Return non-nil if
;; there's a bad line, setting match data 0 to encompass it and
;; leaving point ready for the next search."
;; 
;;   nil)

