;; Copyright 2007, 2009, 2017 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'quick-yes)
  (yes-or-no-p "Yes or no? "))

(yes-or-no-p "Top yes or no? ")

(let ((enable-recursive-minibuffers t))
  (yes-or-no-p "Recursive yes or no? "))


;;-----------------------------------------------------------------------------
(let ((use-dialog-box     t)
      (last-nonmenu-event nil))
  (yes-or-no-p "Yes or no? "))

x-popup-dialog

;;-----------------------------------------------------------------------------
;; This was an idea to let novice users load quick yes by customizing
;; `emacs-startup-hook' or similar hook in the startup sequence.  But as of
;; emacs23 they're just defvars not defcustom.

;;;###autoload
(defun quick-yes-enable ()
  (interactive)
  (ad-enable-advice 'yes-or-no-p 'around 'quick-yes)
  (ad-activate 'yes-or-no-p))

(defun quick-yes-disable ()
  (interactive)
  (ad-disable-advice 'yes-or-no-p 'around 'quick-yes)
  (ad-activate 'yes-or-no-p))

;;;###autoload
(custom-add-option 'emacs-startup-hook 'quick-yes-enable)
