;; Copyright 2011, 2012, 2016 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

/usr/share/doc/wx2.8-doc/wx-manual.html/wx.htx.gz

$toolbar->AddControl($button);
GetExtension
wxApp
SetAppName
Wx::Event::EVT_COMMAND
EVT_COMMAND
EVT_BUTTON
RichTextCtrl
SetValue

;; mangled
EVT_KEY
EVT_ERASE_BACKGROUND

EVT_MOTION
EVT_MOUSEWHEEL

;;-----------------------------------------------------------------------------
;; html entities in index

(progn
  (require 'wx-look)
  (switch-to-buffer "*d-wx-look.el entities*")
  (erase-buffer)
  (dolist (pair (wx-lookup-cache-init))
    (if (string-match "&" (car pair))
        (insert (format "%S\n" pair)))
    (if (string-match "<" (car pair))
        (insert (format "%S\n" pair))))
  (goto-char (point-min)))

;;-----------------------------------------------------------------------------
;; aliases

(progn
  (require 'wx-look)
  (wx-lookup-reset)
  (wx-lookup-cache-init))

;;-----------------------------------------------------------------------------
;; wx.hhk

<OBJECT type="text/sitemap">
  <param name="Local" value="wx_wxapp.html#wxappctor">
  <param name="Name" value="wxApp::wxApp">
  </OBJECT>

"<OBJECT[^>]*>\\s-+\
<param name=\"Local\" value=\"\\([^\">]+\\)\">\\s-+\
<param name=\"Name\" value=\"\\([^\">]+\\)\">"



(progn
  (require 'wx-look)
  (let ((filename (expand-file-name "wx.htx.gz" wx-lookup-manual-directory)))
))

;;-----------------------------------------------------------------------------
;; wx.htx.gz method duplicates

(progn
  (require 'wx-look)
  (let ((filename (expand-file-name "wx.htx.gz" wx-lookup-manual-directory)))
    (switch-to-buffer "*wx*")
    (erase-buffer)

    (with-temp-buffer
      (insert-file-contents filename)

      (let ((count 0)
            (count-other 0)
            (hash (make-hash-table :test 'equal))
            prev)
        (goto-char (point-min))
        (while (re-search-forward "^\\([^|\n]*\\)|\\([^|\n]*\\)|\\s-*\\([^|\n]*\\)\n"
                                  nil t)
          (let ((link (match-string 1))
                (file (match-string 2))
                (name (match-string 3)))

            (if (string-match ".*::" name)
                (setq name (substring name (match-end 0))))

            (let ((elem (list name file link)))

              (cond ((equal elem prev)
                     (setq count (1+ count))
                     (with-current-buffer "*wx*"
                       (insert name "\n")))
                    ((gethash elem hash)
                     (setq count-other (1+ count-other))
                     (with-current-buffer "*wx*"
                       (insert name "\n"))))

              (puthash elem nil hash)
              (setq prev elem))))

        (with-current-buffer "*wx*"
          (insert (format "%d total\n" count))
          (insert (format "%d other\n" count-other)))))))


;;-----------------------------------------------------------------------------
;; wx.htx.gz length

(let ((filename (expand-file-name
                 "wx.htx.gz" wx-lookup-manual-directory)))
  (with-temp-buffer
    (insert-file-contents filename)
    (count-lines (point-min) (point-max))))

(let ((filename (expand-file-name
                 "wx.hhk.gz" wx-lookup-manual-directory)))
  (with-temp-buffer
    (insert-file-contents filename)
    (count-matches
     "<OBJECT[^>]*>\\s-+\
<param name=\"Local\" value=\"\\([^\">#]+\\)#\\([^\">]+\\)\">\\s-+\
<param name=\"Name\" value=\"\\([^\">]+\\)\">"
     (point-min) (point-max))))


;;-----------------------------------------------------------------------------
;; htx/hhk entries

(let ((wx-lookup-manual-directory "/tmp"))
  (ignore-errors (delete-file "/tmp/wx.htx.gz"))
  (ignore-errors (delete-file "/tmp/wx.hhk.gz"))
  (copy-file "/usr/share/doc/wx2.8-doc/wx-manual.html/wx.htx.gz"
             "/tmp/wx.htx.gz")
  (wx-lookup-reset)
  (with-temp-file "/tmp/htx"
    (let ((standard-output (current-buffer)))
    (dolist (elem (wx-lookup-cache-init))
      (prin1 elem) (terpri))))

  (ignore-errors (delete-file "/tmp/wx.htx.gz"))
  (ignore-errors (delete-file "/tmp/wx.hhk.gz"))
  (copy-file "/usr/share/doc/wx2.8-doc/wx-manual.html/wx.hhk.gz"
             "/tmp/wx.hhk.gz")
  (wx-lookup-reset)
  (with-temp-file "/tmp/hhk"
    (let ((standard-output (current-buffer)))
    (dolist (elem (wx-lookup-cache-init))
      (prin1 elem) (terpri))))

  (diff "/tmp/htx" "/tmp/hhk"))


;;-----------------------------------------------------------------------------
;; alphabetical

(progn
  (wx-lookup-reset)
  (switch-to-buffer "*wx*")
  (erase-buffer)
  (dolist (elem
           ;; (wx-lookup-cache-init)
           (sort* (copy-list (wx-lookup-cache-init)) 'string-lessp :key 'car)
           )
    (insert (car elem)
            " -- file://" wx-lookup-manual-directory
            "/" (cadr elem) "#" (cddr elem) "\n"))
  (toggle-truncate-lines 1)
  (goto-char (point-min)))


;;-----------------------------------------------------------------------------
;; globals like ::wxAboutBox

(assoc "::wxAboutBox" (wx-lookup-cache-init))
(wx-lookup-assoc-string-ignore-case "::wxAboutBox" (wx-lookup-cache-init))
wx-lookup-cache


;;-----------------------------------------------------------------------------
;; wx-lookup-completing-help-get

(progn
  (wx-lookup-reset)
  (car (wx-lookup-cache-init)))
(wx-lookup-completing-help-get "wxApp")


;;-----------------------------------------------------------------------------
;; with-auto-compression

(featurep 'jka-compr)
auto-compression-mode
jka-compr-installed-p
(macroexpand '(with-auto-compression-mode
               (message "hello")))
(let ((already-installed (jka-compr-installed-p)))
  (unwind-protect (progn
		    (unless already-installed
		      (jka-compr-install))
		    (message "hello"))
    (unless already-installed
      (jka-compr-uninstall))))


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------------------------------------------------------------------

(progn
  (switch-to-buffer "x")
  (erase-buffer)
  (call-process "dpkg" nil t nil
                "-L" "wx3.0-doc")
  (goto-char (point-min))
  (while (re-search-forward ".*\\.\\(html\\|png\\|js\\|css\\)\n"
                            nil t)
    (delete-region (match-beginning 0) (match-end 0)))
  (goto-char (point-min)))
