#!/usr/bin/perl -w

# Copyright 2009, 2010, 2012 Kevin Ryde.

# This file is part of miscbits-el.
#
# miscbits-el is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3, or (at your option) any later
# version.
#
# miscbits-el is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with miscbits-el; see the file COPYING.  Failing that, go to
# <http://www.gnu.org/licenses/>.


# Usage: perl grep-autoload-blank.pl
#

use 5.010;
use strict;
use warnings;
use POSIX ();
use Perl6::Slurp;
use IO::Uncompress::Gunzip ;
use Iterator::Simple qw(igrep);
use Iterator::Simple::Locate;

use lib::abs '.';
use MyStuff;
use MyUniqByInode;

my $verbose = 0;

#check_file('/usr/share/emacs/24.2/lisp/files.el.gz');
check_file('/down/cc-mode/admin/derived-mode-ex.el');
#exit 0;

my $it = Iterator::Simple::Locate->new (globs => [
                                                  '*.el',
                                                  '*.el.gz'
                                                 ]);
$it = igrep { -e $_ } $it;
{ my $uniq = MyUniqByInode->new;
  $it = igrep { $uniq->uniq($_) } $it;
}

while (my $filename = $it->next) {
  next if $filename =~ m{^/(backup|copy)};
  if ($verbose) { print "look at $filename\n"; }
  check_file($filename);
}

sub check_file {
  my ($filename) = @_;

  my $str = zslurp($filename) // return;
  # print $filename,$str; exit 0;

  # string-match "^...$"
  #
  while ($str =~ /string-match "(\^|[^"]*\$")/g) {
    my ($line, $col) = MyStuff::pos_to_line_and_column ($str, $-[0]);
    print "$filename:$line:$col:\n$&\n";
  }
}

sub zslurp {
  my ($filename) = @_;

  # open my $fh, '<', $filename
  #   or die $!;
  # $! = 0;
  # binmode $fh, ':gzip(auto)'
  #   or die $!;

  my $str;
  eval { $str = Perl6::Slurp::slurp(['gzip(auto)'=>1],$filename); 1 }
    or do {
      #         if ($! == POSIX::ENOENT) {
      #        }
      print "Cannot read $filename: $!\n";
      return;
    };
  return $str;


  # my $str;
  # if ($filename =~ /\.gz$/) {
  #   IO::Uncompress::Gunzip::gunzip ($filename => \$str)
  #       or do {
  #         print "Cannot gunzip $filename: $IO::Uncompress::Gunzip::GunzipError\n";
  #         return;
  #       };
  #
  # } else {
  #   eval { $str = Perl6::Slurp::slurp($filename); 1 }
  #     or do {
  #       #         if ($! == POSIX::ENOENT) {
  #       #        }
  #       print "Cannot read $filename: $!\n";
  #       return;
  #     };
  # }
}
exit 0;
