;; Copyright 2014 Kevin Ryde

;; This file is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; This file is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with this file; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(defun my-texinfo-un@ (str)
  (dolist (item '("{" "}" "@") str)
    (setq str (replace-regexp-in-string (concat "@" item) item str t t))))

(defun my-texinfo-guile-scheme-eval-str (str)
  (let ((orig-buffer (current-buffer)))
    (with-temp-buffer
      (insert "(use-modules (ice-9 format))\n"
              "(use-modules (ice-9 session))\n"
              "(use-modules (ice-9 optargs))\n"
              "(use-modules (ice-9 popen))\n"
              "(use-modules (ice-9 rdelim))\n"
              "(use-modules (ice-9 receive))\n"
              "(use-modules (ice-9 regex))\n"
              "(use-modules (srfi srfi-1))\n"
              "(use-modules (srfi srfi-10))\n"
              "(use-modules (srfi srfi-17))\n"
              "(use-modules (srfi srfi-39))\n"
;;              "(use-modules (gtk-2.0 gdk-pixbuf))\n"
              "(let* ((port   (open-output-string))\n"
              "       (result (with-output-to-port port (lambda ()"
              str
              "        )))\n"
              "       (out    (get-output-string port)))\n\n"
              "  (if (not (string-null? out))\n"
              "      (begin\n"
              "        (format #t \"@print{} ~a\" out)\n"
              "        (if (not (eq? result (display \"\")))\n"
              "          (display \" \"))))\n"
              "  (if (not (eq? result (display \"\")))\n"
              "      (format #t \"@result{} ~s\" result)))\n")
      (call-process-region (point-min) (point-max)
                           ;; "guile-1.6"
                           "/down/guile-core/b/pre-inst-guile"
                           nil orig-buffer t
                           "-s" "/dev/stdin"))))

(defun my-texinfo-guile-scheme-eval-last-sexp (&optional arg)
  "Evaluate the preceding S-expression using Guile.
The result is inserted in the buffer with @result{}, and any output with
@print{}.
With a prefix ARG, pass everything from point to mark to Guile."
  (interactive "P")
  (my-texinfo-guile-scheme-eval-str
   (my-texinfo-un@ (buffer-substring
                    (if arg
                        (mark)
                      (save-excursion (backward-sexp) (point)))
                    (point)))))

;; (define-key texinfo-mode-map "\C-x\C-e" 'my-texinfo-guile-scheme-eval-last-sexp)
